﻿angular.module("umbraco")
    .controller("memberExport.exportController",
        function ($scope,$rootScope, $routeParams, notificationsService, dialogService, memberExportBackofficeResources, memberExportHelper) {
            $scope.bindData = function () {

                memberExportBackofficeResources.initializeForm($routeParams.id).then(function (res) {
                        $scope.model = res.data;
                        $scope.model.saveForm = false;
                        $scope.loaded = true;
                        memberExportHelper.syncPath($scope.model.path);
                    },
                    function (data) {
                        memberExportHelper.showServerError();
                    });
            };
            
            $scope.updateModel = function () {
                memberExportBackofficeResources.updateModel($scope.model).then(function (res) {
                        $scope.model = res.data;
                    },
                    function (data) {
                        memberExportHelper.showServerError();
                    });
            };
            $scope.save = function () {
                memberExportBackofficeResources.saveModel($scope.model).then(function (res) {
                        $scope.model = res.data;
                        $scope.model.saveForm = $scope.model.isInValid ===true;
                        memberExportHelper.syncPath($scope.model.path);
                        memberExportHelper.showNotification($scope.model.notificationStatus);
                    },
                    function (data) {
                        memberExportHelper.showServerError();
                    });
            };

            $scope.export = function() {
                memberExportBackofficeResources.exportData($scope.model).success(function (data, status, headers, config) {
                var url = memberExportBackofficeResources.getExportUrl(data);
                    memberExportHelper.downloadFile(url);
                }).error(function (data, status, headers, config) {
                    //upload failed
                    notificationsService.error('Error', 'Error exporting members');
                });
            }
            $scope.cancel  = function() {
                $scope.model.isInValid = false;
                $scope.model.validationMessages.length = 0;
                $scope.model.saveForm = false;
            }
            $rootScope.$on("memberexportDropdown.changed", function (event, data) {
                if (data.alias === 'memberType') {
                    $scope.model.resetProperties = true;
                    $scope.updateModel();
                }
                if (data.alias === 'exportAs') {
                    $scope.updateModel();
                }
            });

            $scope.buttonGroup = {
                defaultButton: {
                    labelKey: "memberExportGeneral_exportButtonCaption",
                    hotKey: "ctrl+e",
                    hotKeyWhenHidden: true,
                    handler: function () {
                        $scope.export();
                    }
                },
                subButtons: [
                    {
                        labelKey: "buttons_save",
                        hotKey: "ctrl+s",
                        hotKeyWhenHidden: false,
                        handler: function () {
                            $scope.model.saveForm = true;
                        }
                    }
                ]
            };
            
            //Initialize
            $scope.bindData();
        });