﻿angular.module("umbraco.directives")
.directive('memberexportDatepicker', function ($parse, $filter, assetsService, memberExportHelper) {
    return {
        restrict: 'E',
        scope: {
            field: '=',
        },
        controller: function ($scope, $element) {
            assetsService.loadCss('/umbraco/lib/datetimepicker/bootstrap-datetimepicker.min.css').then(function () {
                var filesToLoad = ["/umbraco/lib/moment/moment-with-locales.js",
                                   "/umbraco/lib/datetimepicker/bootstrap-datetimepicker.js"];
                assetsService.load(filesToLoad, $scope).then(function () {

                    var container = $element.find("div.datepicker");

                    var existingDate = memberExportHelper.parseDate($scope.field) || new Date();
                    $scope.field = memberExportHelper.formatDate(existingDate);  

                    $scope.$watch('field', function (newValue, oldValue) {
                        if (newValue) {
                            $scope._tempfield = memberExportHelper.formatDate(newValue);
                        } else if (oldValue) {
                            $scope._tempfield = memberExportHelper.formatDate(oldValue);
                        }
                    });

                    container.datetimepicker({
                        format: 'YYYY-MM-DD',
                        autoclose: true
                    })
                    .on('changeDate', function (ev) {
                        $scope.field = memberExportHelper.formatDate(ev.date);
                    });
                });
            });
        },
        templateUrl: '/App_Plugins/memberexport/fields/datepicker.html'
    }
});