﻿angular.module("umbraco")
    .controller("memberExport.queryFilterController",
    function ($scope, memberExportBackofficeResources, memberExportHelper, localizationService) {
        $scope.setClass = function (isFirst) {
            if (isFirst) {
                return ' umb-el-wrap ';
            }

            return ' umb-el-wrap memberexportRow';
        };

        $scope.initialize = function () {
            localizationService.localize('memberExportGeneral_optionTrue').then(function (value) {
                $scope.trueCaption = value;
            });

            localizationService.localize('memberExportGeneral_optionFalse').then(function (value) {
                $scope.falseCaption = value;
            });

            memberExportBackofficeResources.initializeFilterOptions($scope.model.value.memberType).then(function (res) {
                $scope.configuration = res.data;
            },
                function (data) {
                    memberExportHelper.showServerError();
                });
        };

        $scope.filteredConfig = function (item) {
            if (!memberExportHelper.isNullOrUndefined($scope.configuration)) {
                var selectedField = $scope.getFieldByAlias(item.fieldAlias);
                var selectedItems = $scope.configuration.operators.filter(function (operator) {
                    return (operator.fieldType === selectedField.exportFieldType);
                });
                return selectedItems;
            }
            return null;
        };

        $scope.booleanText = function(item) {
            return item.value === "true" ?$scope.trueCaption  :$scope.falseCaption ;
        }
        $scope.swapBoolean = function(item) {
            item.value = item.value  === "true" ?"false"  :"true" ;
        }

        $scope.isStringField = function (item) {
            return $scope.getFieldTypeAlias(item.fieldAlias) === 'string';
        }

        $scope.isIntField = function (item) {
            return $scope.getFieldTypeAlias(item.fieldAlias) === 'int';
        }

        $scope.isDateTimeField = function (item) {
            return $scope.getFieldTypeAlias(item.fieldAlias) === 'datetime';
        }

        $scope.isBooleanField = function (item) {
            return $scope.getFieldTypeAlias(item.fieldAlias) === 'boolean';
        }

        $scope.getFieldByAlias = function (fieldAlias) {
            return $scope.configuration.fields.filter(function (field) {
                return (field.fieldAlias === fieldAlias);
            })[0];
        }

        $scope.getFieldTypeAlias = function (fieldAlias) {
            if (!memberExportHelper.isNullOrUndefined($scope.configuration)) {
                var selectedField = $scope.getFieldByAlias(fieldAlias);
                return selectedField.exportFieldType;
            }
            return 'unknown';
        }

        $scope.canRemove = function() {
            return $scope.model.value.items.length >1;
        };

        $scope.addFilter = function () {
            memberExportBackofficeResources.addFilterRow($scope.model.value.items).then(function (res) {
                $scope.model.value.items = res.data;
            },
                function (data) {
                    memberExportHelper.showServerError();
                });
        };
        $scope.remove = function (item) {
            var index = $scope.model.value.items.indexOf(item);
            $scope.model.value.items.splice(index, 1);

        };
     
        
        $scope.initialize();
    });